uniform sampler2D tex;

vec3 rgb_to_hsl(vec3 c) {
    vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
    vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g));
    vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r));

    float d = q.x - min(q.w, q.y);
    float e = 1.0e-10;
    return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}

void main(void) {
    vec2 uv = cogl_tex_coord_in[0].xy;
    vec4 rgba = texture2D(tex, uv);
    vec4 hsla = vec4(rgb_to_hsl(rgba.xyz), rgba.w);
    cogl_color_out = hsla;
}